#include <libreborn/libreborn.h>
#include <symbols/minecraft.h>

#include <mods/init/init.h>
#include <mods/misc/misc.h>
#include <mods/feature/feature.h>
#include "skin-internal.h"

// Change Texture For Player Entities
static void Player_username_assign_injection(std::string *target, std::string *username) {
    // Call Original Method
    *target = *username;

    // Get Player
    Player *player = (Player *) (((unsigned char *) target) - offsetof(Player, username));
    // Get Texture
    std::string *texture = &player->texture;

    // Set Texture
    *texture = '$' + misc_base64_encode(*username);
}
static void Player_username_assign_injection_2(std::string *target, const char *username) {
    std::string username_str = username;
    Player_username_assign_injection(target, &username_str);
}

// Change Texture For HUD
static int32_t Textures_loadAndBindTexture_injection(Textures *textures, __attribute__((unused)) std::string const& name) {
    // Change Texture
    static std::string new_texture;
    if (new_texture.length() == 0) {
        const std::string username = misc_base64_encode(Strings::default_username);
        new_texture = '$' + username;
    }

    // Call Original Method
    return textures->loadAndBindTexture(new_texture);
}

// Init
void init_skin() {
    // Check Feature Flag
    if (feature_has("Load Custom Skins", server_disabled)) {
        // LocalPlayer
        overwrite_call((void *) 0x44c28, (void *) Player_username_assign_injection);
        // RemotePlayer
        overwrite_call((void *) 0x6ce58, (void *) Player_username_assign_injection_2);
        // ServerPlayer
        overwrite_call((void *) 0x7639c, (void *) Player_username_assign_injection_2);

        // HUD
        overwrite_call((void *) 0x4c6d0, (void *) Textures_loadAndBindTexture_injection);

        // Loader
        _init_skin_loader();
    }
}
